﻿using System;
using System.IO.Ports;
using System.Threading;
using System.Threading.Tasks;


namespace ApiServer
{
    public class GetActualStateFromCom : IHostedService, IDisposable
    {
        public static byte CurrentState { get; set; }

        static SerialPort _serialPort;

        static void DataReceivedHandler(object sender, SerialDataReceivedEventArgs e)
        {
            SerialPort serialPort = (SerialPort)sender;
            string receivedData = serialPort.ReadExisting();

            Console.WriteLine("Полученные данные: " + receivedData);
            CurrentState = Convert.ToByte(receivedData);
        }

        public Task StartAsync(CancellationToken cancellationToken)
        {
            string portName = "COM3";
            int baudRate = 9600;

            _serialPort = new SerialPort(portName, baudRate);
            _serialPort.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);
            _serialPort.Open();

            Console.WriteLine("Чтение данных с порта: " + portName);

            return Task.CompletedTask;
        }

        public Task StopAsync(CancellationToken cancellationToken)
        {
            return Task.CompletedTask;
        }

        public void Dispose()
        {
            _serialPort.Dispose();
        }
    }
}
