﻿using Modbus.Device;
using System.IO.Ports;


namespace ApiServer
{
	public class GetActualStateFromComWithModbus : BackgroundService, IDisposable
	{
		public static bool[] CurrentState { get; set; }

		private static SerialPort? _serialPort;
		private static ModbusSerialMaster? _serialMaster;

		protected override async Task ExecuteAsync(CancellationToken stoppingToken)
		{
			_serialPort = new SerialPort();
			_serialPort.PortName = "COM5";
			_serialPort.BaudRate = 9600;
			_serialPort.DataBits = 8;
			_serialPort.Parity = Parity.None;
			_serialPort.StopBits = StopBits.One;
			_serialPort.Open();

			_serialMaster = ModbusSerialMaster.CreateRtu(_serialPort);
			byte slaveID = 1;
			ushort startAddress = 0;
			ushort numOfPoints = 2;

			while (!stoppingToken.IsCancellationRequested)
			{
				CurrentState = _serialMaster.ReadInputs(slaveID, startAddress, numOfPoints);
				await Task.Delay(100, stoppingToken);
			}
			await Task.CompletedTask;
		}
	}
}
