﻿using System;
using System.Net;
using System.Net.Sockets;
using System.Text;

public class Server
{
    public static void Main()
    {
        // Настройка IP-адреса сервера и номера порта.
        var serverAddress = IPAddress.Parse("0.0.0.0");
        var serverPort = 8000;

        // Создаем наш серверный сокет.
        var serverSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

        // Привязка сокета.
        serverSocket.Bind(new IPEndPoint(serverAddress, serverPort));

        // Сервер прослушивает соединения.
        serverSocket.Listen(5);
        Console.WriteLine("Сервер прослушивает соединения...");

        while (true)
        {
            // Принятие клиентского соединения.
            var clientSocket = serverSocket.Accept();
            Console.WriteLine("Клиент подключен!");

            // Получение сообщения от клиента.
            var temp = new byte[1024];
            var clientBytes = clientSocket.Receive(temp);
            var clientMessage = Encoding.ASCII.GetString(temp, 0, clientBytes);
            Console.WriteLine("Получены данные от клиента: " + clientMessage);

            // Обработка и отправка клиенту новых данных. 

            // Отправка сообщения обратно клиенту.

            var serverMessage = string.Empty;
            
            if (clientMessage.Contains("GET /post"))
            {
                serverMessage = "HTTP/1.1 200 OK\r\nContent-Type: text/html; charset=UTF-8\r\n\r\n<!DOCTYPE html><html><head><title>Пример страницы</title></head><body><h1>Привет, мир!</h1><p>Страница с постами!</p></body></html>";
            }
            else if (clientMessage.Contains("GET /admin"))
            {
                serverMessage = "HTTP/1.1 200 OK\r\nContent-Type: text/html; charset=UTF-8\r\n\r\n<!DOCTYPE html><html><head><title>Пример страницы</title></head><body><h1>Привет, мир!</h1><p>Страница администратора!</p></body></html>";
            }
            else
            {
                serverMessage = "HTTP/1.1 200 OK\r\nContent-Type: text/html; charset=UTF-8\r\n\r\n<!DOCTYPE html><html><head><title>Пример страницы</title></head><body><h1>Привет, мир!</h1><p>Базовая страница!</p></body></html>";
            }

            var messageBytes = Encoding.UTF8.GetBytes(serverMessage);
            clientSocket.Send(messageBytes);
            
            // Закрытие соединения.
            clientSocket.Shutdown(SocketShutdown.Both);
            clientSocket.Close();
        }
    }
}

